varying vec4 color;
uniform sampler2D floorTex;
uniform sampler2D furFloorTex;
uniform float furLength;

uniform sampler2DShadow shadowMap;

void main()
{
	vec4 texel, fur;
	
	float depth = shadow2DProj(shadowMap, gl_TexCoord[0]).x * 0.8 + 0.2;
	
  if (furLength > 0) {
    texel = texture2D(floorTex, gl_TexCoord[1].st);
    fur = texture2D(furFloorTex, gl_TexCoord[1].st);
    color = vec4((color.rgb * texel.rgb * vec3(texel.r,texel.r,texel.r)) * depth, color.a * fur.a);
  }
  else
    color = vec4(0,0,0,1);
  
	gl_FragColor = color;
}
