varying vec4 color;
uniform float furLength;

uniform mat4 texMatrix;

void main()
{	
  //get new vertex position
  vec4 pos = vec4(gl_Vertex);
  vec4 n = normalize(vec4(gl_Normal, 0));
  pos += furLength * n;
	
  //we do flat shading, so calculate color here
	vec3 lightDir = normalize(vec3(gl_LightSource[0].position));
	vec3 normal = normalize(gl_NormalMatrix * gl_Normal);
				
	vec4 diffuse = gl_FrontMaterial.diffuse * gl_LightSource[0].diffuse;
	color = gl_FrontMaterial.ambient * (gl_LightSource[0].ambient + gl_LightModel.ambient);
	color += diffuse * max(dot(normal,lightDir),0.0);
	
	//vec4 gravity = vec4(0,g,0,0);
	//mat4 matModelInverse = gl_ModelViewMatrixInverse * matView;
	//vec4 modelGravity = matModelInverse * gravity;
	//vec4 modelGravity = graVec;
	//pos += gravity * (pow(furLength*1.5,2.0) * (1 - abs(dot(n, normalize(gravity)))));
	
  gl_TexCoord[0] = texMatrix * gl_ModelViewMatrix * pos;
  
  gl_TexCoord[1] = gl_MultiTexCoord1;
	gl_Position = gl_ModelViewProjectionMatrix * pos;
} 
