varying vec4 color;
uniform sampler2D tex;
uniform float furLength;

uniform sampler2DShadow shadowMap;

void main()
{
	vec4 texel;
	
	float depth = shadow2DProj(shadowMap, gl_TexCoord[1]).x * 0.8 + 0.2;
	
  if (furLength > 0) {
    texel = texture2D(tex, gl_TexCoord[0].st);
    color = vec4((color.rgb * texel.rgb) * depth, color.a * texel.a);
  }
  else
    color = vec4(0,0,0,1);
  
	gl_FragColor = color;
}
