varying vec4 diffuse,ambient;
varying vec3 normal,lightDir,halfVector;
uniform sampler2D normalMap1;	//normal map
uniform sampler2D normalMap2;	//70er wallpaper
uniform float depthTexStep;
		
uniform sampler2DShadow shadowMap;

void main()
{
	vec3 n, halfV;
	float NdotL, NdotHV;
	
	float depth = shadow2DProj(shadowMap, gl_TexCoord[0]).x * 0.8 + 0.2;
	
	vec4 normal_map_normal = texture2D(normalMap1,gl_TexCoord[1].st);
	vec4 color = texture2D(normalMap2,gl_TexCoord[1].st);
	color.rgb = color.rgb*0.5;
	
	float step = depthTexStep/gl_TexCoord[0].w;
	float step2 = 2 * step;
	
	float neighbourhoodSum = 
    shadow2DProj(shadowMap, gl_TexCoord[0]+vec4(0,step,0,0)).x + 
    shadow2DProj(shadowMap, gl_TexCoord[0]+vec4(0,-step,0,0)).x + 
    shadow2DProj(shadowMap, gl_TexCoord[0]+vec4(step,0,0,0)).x + 
    shadow2DProj(shadowMap, gl_TexCoord[0]+vec4(-step,0,0,0)).x + 
    shadow2DProj(shadowMap, gl_TexCoord[0]+vec4(step,step,0,0)).x + 
    shadow2DProj(shadowMap, gl_TexCoord[0]+vec4(step,-step,0,0)).x + 
    shadow2DProj(shadowMap, gl_TexCoord[0]+vec4(-step,step,0,0)).x + 
    shadow2DProj(shadowMap, gl_TexCoord[0]+vec4(-step,-step,0,0)).x;
    
  /**/if (depth == 1.0 && neighbourhoodSum != 8.0)
    depth = 1.0 - (8.0 - neighbourhoodSum) * 0.1;
  //else if (depth == 0.0 && neighbourhoodSum > 3.0)
    //depth = 0.8;
	
	n = normalize(normal+vec3(normal_map_normal.rgb));
	
	NdotL = max(dot(n,lightDir),0.0);
	vec4 shadowColor = 0.1 * dot(n,vec3(0,-1,0))* depth;

	if (NdotL > 0.0) {
		color += diffuse * NdotL * depth + shadowColor;
		halfV = normalize(halfVector);
		NdotHV = max(dot(n,halfV),0.0);
		color += gl_FrontMaterial.specular * 
				gl_LightSource[0].specular * 
				pow(NdotHV, gl_FrontMaterial.shininess) * depth;
	}
	else {
		color = shadowColor+color;
	}
	//gl_FragColor = realColor;
	gl_FragColor = color;//(texColor.rgb * color.rgb, texColor.a * color.a);
}
