varying vec4 diffuse,ambient;
varying vec3 normal,lightDir,halfVector;

uniform mat4 texMatrix;

void main()
{
  vec4 eyePos = gl_ModelViewMatrix * gl_Vertex;
  
  gl_TexCoord[0] = texMatrix * eyePos;

	normal = normalize(gl_NormalMatrix * gl_Normal);
	lightDir = normalize(vec3(gl_LightSource[0].position));
	halfVector = normalize(gl_LightSource[0].halfVector.xyz);
				
	diffuse = gl_FrontMaterial.diffuse * gl_LightSource[0].diffuse;
	ambient = gl_FrontMaterial.ambient * gl_LightSource[0].ambient;
	ambient += gl_LightModel.ambient * gl_FrontMaterial.ambient;

	gl_TexCoord[1] = gl_TextureMatrix[1] * gl_MultiTexCoord1;
	gl_Position = ftransform();
} 
